/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern17 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern17 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern17 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern17 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern17 (x3, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x3) != E_V1HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1QImode:
          if (!register_operand (operands[1], E_V1QImode)
              || !register_operand (operands[2], E_V1QImode))
            return -1;
          return 0;

        case E_V2QImode:
          if (!register_operand (operands[1], E_V2QImode)
              || !register_operand (operands[2], E_V2QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V2HImode:
      if (pattern14 (x3, 
E_V4QImode, 
E_V2HImode) != 0)
        return -1;
      return 2;

    case E_V4HImode:
      if (pattern14 (x3, 
E_V8QImode, 
E_V4HImode) != 0)
        return -1;
      return 3;

    case E_V8HImode:
      if (pattern14 (x3, 
E_V16QImode, 
E_V8HImode) != 0)
        return -1;
      return 4;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x3) != E_V1SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1HImode:
          if (!register_operand (operands[1], E_V1HImode)
              || !register_operand (operands[2], E_V1HImode))
            return -1;
          return 5;

        case E_V2HImode:
          if (!register_operand (operands[1], E_V2HImode)
              || !register_operand (operands[2], E_V2HImode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_V2SImode:
      if (pattern14 (x3, 
E_V4HImode, 
E_V2SImode) != 0)
        return -1;
      return 7;

    case E_V4SImode:
      if (pattern14 (x3, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 8;

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x3) != E_V1DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1SImode:
          if (!register_operand (operands[1], E_V1SImode)
              || !register_operand (operands[2], E_V1SImode))
            return -1;
          return 9;

        case E_V2SImode:
          if (!register_operand (operands[1], E_V2SImode)
              || !register_operand (operands[2], E_V2SImode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_V2DImode:
      if (pattern14 (x3, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern55 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern54 (x1, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern54 (x1, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern54 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern62 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[4] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern61 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern61 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern67 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern74 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  return 0;
}

int
pattern79 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != 26)
    return -1;
  x6 = XVECEXP (x5, 0, 1);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 1)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 1)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != LABEL_REF)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x10) != USE)
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x11) != USE)
    return -1;
  return 0;
}

int
pattern88 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 33
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern93 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern99 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i2)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern106 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern113 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern112 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern112 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern119 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern118 (x5, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern118 (x5, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_HImode:
      if (pattern118 (x5, 
E_HImode) != 0)
        return -1;
      return 2;

    case E_QImode:
      if (pattern118 (x5, 
E_QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern130 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x2, 1);
  if (XWINT (x5, 0) != 64L)
    return -1;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1
      || GET_MODE (x7) != E_DImode)
    return -1;
  return 0;
}

int
pattern135 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern134 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern134 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern141 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!nonimmediate_operand (operands[0], E_DImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != E_DImode)
    return -1;
  return 0;
}

int
pattern150 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern149 (x1); /* [-1, 5] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode))
            return -1;
          switch (GET_MODE (x6))
            {
            case E_DImode:
              if (!immediate_operand (operands[2], E_DImode))
                return -1;
              return 6;

            case E_SImode:
              if (!immediate_operand (operands[2], E_SImode))
                return -1;
              return 7;

            default:
              return -1;
            }

        case E_TFmode:
          if (!register_operand (operands[1], E_TFmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 8;

        case E_FPRX2mode:
          if (!register_operand (operands[1], E_FPRX2mode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 9;

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 10;

        case E_TDmode:
          if (!register_operand (operands[1], E_TDmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 11;

        case E_DDmode:
          if (!register_operand (operands[1], E_DDmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 12;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern176 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern181 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern188 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !general_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !general_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern193 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!nonmemory_operand (operands[2], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!immediate_operand (operands[3], E_VOIDmode))
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  switch (GET_MODE (operands[4]))
    {
    case E_DImode:
      if (!scratch_operand (operands[4], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!scratch_operand (operands[4], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern203 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern209 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !s390_slb_comparison (operands[3], i1))
    return -1;
  return 0;
}

int
pattern218 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern227 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern236 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern241 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern249 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern257 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern267 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1
      || !nonimmediate_operand (operands[2], i2))
    return -1;
  x7 = XEXP (x1, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern285 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || pattern282 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern292 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (pattern17 (x3, 
E_V16QImode) != 0
          || !
#line 1133 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 234; /* vec_srabv16qi */

    case E_V8HImode:
      if (pattern17 (x3, 
E_V8HImode) != 0
          || !
#line 1133 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 235; /* vec_srabv8hi */

    case E_V4SImode:
      if (pattern17 (x3, 
E_V4SImode) != 0
          || !
#line 1133 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 236; /* vec_srabv4si */

    case E_V2DImode:
      if (pattern17 (x3, 
E_V2DImode) != 0
          || !
#line 1133 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 237; /* vec_srabv2di */

    case E_V1TImode:
      if (pattern17 (x3, 
E_V1TImode) != 0
          || !
#line 1133 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 238; /* vec_srabv1ti */

    case E_TImode:
      if (pattern126 (x3, 
E_V1TImode, 
E_TImode) != 0
          || !
#line 1133 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 239; /* vec_srabti */

    case E_V2DFmode:
      if (pattern126 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
          || !
#line 1133 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 240; /* vec_srabv2df */

    case E_V4SFmode:
      if (pattern126 (x3, 
E_V4SImode, 
E_V4SFmode) != 0
          || !(
#line 1133 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 31 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 241; /* vec_srabv4sf */

    case E_V1TFmode:
      if (pattern126 (x3, 
E_V1TImode, 
E_V1TFmode) != 0
          || !(
#line 1133 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 31 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 242; /* vec_srabv1tf */

    case E_TFmode:
      if (pattern126 (x3, 
E_V1TImode, 
E_TFmode) != 0
          || !(
#line 1133 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 32 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 243; /* vec_srabtf */

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XINT (x3, 1))
    {
    case 71:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern17 (x3, 
E_V8HImode) != 0
              || !
#line 402 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 33; /* vec_zpermv8hi */

        case E_V4SImode:
          if (pattern17 (x3, 
E_V4SImode) != 0
              || !
#line 402 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 34; /* vec_zpermv4si */

        case E_V4SFmode:
          if (pattern17 (x3, 
E_V4SFmode) != 0
              || !(
#line 402 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 35 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 35; /* vec_zpermv4sf */

        case E_V2DImode:
          if (pattern17 (x3, 
E_V2DImode) != 0
              || !
#line 402 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 36; /* vec_zpermv2di */

        case E_V2DFmode:
          if (pattern17 (x3, 
E_V2DFmode) != 0
              || !
#line 402 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 37; /* vec_zpermv2df */

        case E_V16QImode:
          if (pattern17 (x3, 
E_V16QImode) != 0
              || !
#line 746 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 539; /* vec_permv16qi */

        default:
          return -1;
        }

    case 81:
      if (pattern50 (x3) != 0
          || !
#line 677 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 112; /* vacq */

    case 82:
      if (pattern50 (x3) != 0
          || !
#line 690 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 113; /* vacccq */

    case 88:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 870 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 136; /* vec_gfmsum_accumv16qi */

        case 1:
          if (!
#line 870 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 137; /* vec_gfmsum_accumv8hi */

        case 2:
          if (!
#line 870 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 138; /* vec_gfmsum_accumv4si */

        default:
          return -1;
        }

    case 89:
      if (pattern53 (x3, 
E_V2DImode, 
E_V16QImode) != 0)
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_V16QImode)
          || !
#line 880 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 139; /* vec_gfmsum_accum_128 */

    case 52:
      switch (pattern55 (x3))
        {
        case 0:
          if (!
#line 902 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 140; /* vec_vmalv16qi */

        case 1:
          if (!
#line 902 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 141; /* vec_vmalv8hi */

        case 2:
          if (!
#line 902 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 142; /* vec_vmalv4si */

        default:
          return -1;
        }

    case 53:
      switch (pattern55 (x3))
        {
        case 0:
          if (!
#line 915 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 143; /* vec_vmahv16qi */

        case 1:
          if (!
#line 915 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 144; /* vec_vmahv8hi */

        case 2:
          if (!
#line 915 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 145; /* vec_vmahv4si */

        default:
          return -1;
        }

    case 54:
      switch (pattern55 (x3))
        {
        case 0:
          if (!
#line 926 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 146; /* vec_vmalhv16qi */

        case 1:
          if (!
#line 926 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 147; /* vec_vmalhv8hi */

        case 2:
          if (!
#line 926 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 148; /* vec_vmalhv4si */

        default:
          return -1;
        }

    case 55:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 939 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 149; /* vec_vmaev16qi */

        case 1:
          if (!
#line 939 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 150; /* vec_vmaev8hi */

        case 2:
          if (!
#line 939 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 151; /* vec_vmaev4si */

        default:
          return -1;
        }

    case 56:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 950 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 152; /* vec_vmalev16qi */

        case 1:
          if (!
#line 950 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 153; /* vec_vmalev8hi */

        case 2:
          if (!
#line 950 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 154; /* vec_vmalev4si */

        default:
          return -1;
        }

    case 57:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 963 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 155; /* vec_vmaov16qi */

        case 1:
          if (!
#line 963 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 156; /* vec_vmaov8hi */

        case 2:
          if (!
#line 963 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 157; /* vec_vmaov4si */

        default:
          return -1;
        }

    case 58:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 974 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 158; /* vec_vmalov16qi */

        case 1:
          if (!
#line 974 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 159; /* vec_vmalov8hi */

        case 2:
          if (!
#line 974 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 160; /* vec_vmalov4si */

        default:
          return -1;
        }

    case 97:
      switch (pattern56 (x3))
        {
        case 0:
          if (!
#line 1075 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 192; /* vec_sldv16qi */

        case 1:
          if (!
#line 1075 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 193; /* vec_sldv8hi */

        case 2:
          if (!
#line 1075 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 194; /* vec_sldv4si */

        case 3:
          if (!
#line 1075 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 195; /* vec_sldv2di */

        case 4:
          if (!
#line 1075 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 196; /* vec_sldv1ti */

        case 5:
          if (!
#line 1075 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 197; /* vec_sldti */

        case 6:
          if (!
#line 1075 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 198; /* vec_sldv2df */

        case 7:
          if (!(
#line 1075 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 31 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 199; /* vec_sldv4sf */

        case 8:
          if (!(
#line 1075 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 31 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 200; /* vec_sldv1tf */

        case 9:
          if (!(
#line 1075 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 32 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 201; /* vec_sldtf */

        default:
          return -1;
        }

    case 98:
      switch (pattern56 (x3))
        {
        case 0:
          if (!
#line 1098 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 202; /* vec_sldbv16qi */

        case 1:
          if (!
#line 1098 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 203; /* vec_sldbv8hi */

        case 2:
          if (!
#line 1098 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 204; /* vec_sldbv4si */

        case 3:
          if (!
#line 1098 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 205; /* vec_sldbv2di */

        case 4:
          if (!
#line 1098 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 206; /* vec_sldbv1ti */

        case 5:
          if (!
#line 1098 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 207; /* vec_sldbti */

        case 6:
          if (!
#line 1098 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 208; /* vec_sldbv2df */

        case 7:
          if (!(
#line 1098 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 31 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 209; /* vec_sldbv4sf */

        case 8:
          if (!(
#line 1098 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 31 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 210; /* vec_sldbv1tf */

        case 9:
          if (!(
#line 1098 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 32 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 211; /* vec_sldbtf */

        default:
          return -1;
        }

    case 99:
      switch (pattern56 (x3))
        {
        case 0:
          if (!
#line 1110 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 212; /* vec_srdbv16qi */

        case 1:
          if (!
#line 1110 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 213; /* vec_srdbv8hi */

        case 2:
          if (!
#line 1110 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 214; /* vec_srdbv4si */

        case 3:
          if (!
#line 1110 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 215; /* vec_srdbv2di */

        case 4:
          if (!
#line 1110 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 216; /* vec_srdbv1ti */

        case 5:
          if (!
#line 1110 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 217; /* vec_srdbti */

        case 6:
          if (!
#line 1110 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 218; /* vec_srdbv2df */

        case 7:
          if (!(
#line 1110 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 31 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 219; /* vec_srdbv4sf */

        case 8:
          if (!(
#line 1110 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 31 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 220; /* vec_srdbv1tf */

        case 9:
          if (!(
#line 1110 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 32 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 221; /* vec_srdbtf */

        default:
          return -1;
        }

    case 105:
      if (pattern50 (x3) != 0
          || !
#line 1185 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 262; /* vsbiq */

    case 106:
      if (pattern50 (x3) != 0
          || !
#line 1198 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 263; /* vsbcbiq */

    case 108:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_mask_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern17 (x3, 
E_V16QImode) != 0
              || !
#line 1290 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 278; /* vfaev16qi */

        case E_V8HImode:
          if (pattern17 (x3, 
E_V8HImode) != 0
              || !
#line 1290 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 279; /* vfaev8hi */

        case E_V4SImode:
          if (pattern17 (x3, 
E_V4SImode) != 0
              || !
#line 1290 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 280; /* vfaev4si */

        default:
          return -1;
        }

    case 110:
      switch (pattern57 (x3))
        {
        case 0:
          if (!
#line 1390 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 284; /* vfeev16qi */

        case 1:
          if (!
#line 1390 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 285; /* vfeev8hi */

        case 2:
          if (!
#line 1390 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 286; /* vfeev4si */

        case 3:
          if (!
#line 1401 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 287; /* vfeezv16qi */

        case 4:
          if (!
#line 1401 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 288; /* vfeezv8hi */

        case 5:
          if (!
#line 1401 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 289; /* vfeezv4si */

        default:
          return -1;
        }

    case 112:
      switch (pattern57 (x3))
        {
        case 0:
          if (!
#line 1449 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 290; /* vfenev16qi */

        case 1:
          if (!
#line 1449 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 291; /* vfenev8hi */

        case 2:
          if (!
#line 1449 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 292; /* vfenev4si */

        case 3:
          if (!
#line 1462 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 293; /* vfenezv16qi */

        case 4:
          if (!
#line 1462 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 294; /* vfenezv8hi */

        case 5:
          if (!
#line 1462 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 295; /* vfenezv4si */

        default:
          return -1;
        }

    case 120:
      if (pattern58 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
          || !
#line 1718 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 311; /* vcdgb */

    case 121:
      if (pattern58 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
          || !
#line 1750 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 312; /* vcdlgb */

    case 122:
      if (pattern58 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
          || !
#line 1781 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 313; /* vcgdb */

    case 123:
      if (pattern58 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
          || !
#line 1814 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 314; /* vclgdb */

    case 124:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!const_mask_operand (operands[2], E_QImode))
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_mask_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V1SFmode:
          if (!register_operand (operands[0], E_V1SFmode)
              || GET_MODE (x3) != E_V1SFmode
              || !register_operand (operands[1], E_V1SFmode)
              || !(
#line 1849 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 59 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 315; /* vec_fpintv1sf */

        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[1], E_V2SFmode)
              || !(
#line 1849 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 59 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 316; /* vec_fpintv2sf */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !(
#line 1849 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 59 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 317; /* vec_fpintv4sf */

        case E_V1DFmode:
          if (!register_operand (operands[0], E_V1DFmode)
              || GET_MODE (x3) != E_V1DFmode
              || !register_operand (operands[1], E_V1DFmode)
              || !
#line 1849 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 318; /* vec_fpintv1df */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 1849 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 319; /* vec_fpintv2df */

        case E_V1TFmode:
          if (!register_operand (operands[0], E_V1TFmode)
              || GET_MODE (x3) != E_V1TFmode
              || !register_operand (operands[1], E_V1TFmode)
              || !(
#line 1849 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 61 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 320; /* vec_fpintv1tf */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode
              || !register_operand (operands[1], E_TFmode)
              || !(
#line 1849 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 61 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 321; /* vec_fpinttf */

        default:
          return -1;
        }

    case 126:
      if (pattern58 (x3, 
E_V4SFmode, 
E_V2DFmode) != 0
          || !
#line 1895 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 323; /* vflrd */

    case 130:
      switch (pattern59 (x3))
        {
        case 0:
          if (!
#line 2152 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 380; /* vfminv4sf */

        case 1:
          if (!
#line 2152 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 381; /* vfminv2df */

        case 2:
          if (!
#line 2152 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 382; /* vfminv1tf */

        case 3:
          if (!
#line 2152 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 383; /* vfmintf */

        default:
          return -1;
        }

    case 131:
      switch (pattern59 (x3))
        {
        case 0:
          if (!
#line 2162 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 384; /* vfmaxv4sf */

        case 1:
          if (!
#line 2162 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 385; /* vfmaxv2df */

        case 2:
          if (!
#line 2162 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 386; /* vfmaxv1tf */

        case 3:
          if (!
#line 2162 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 387; /* vfmaxtf */

        default:
          return -1;
        }

    case 90:
      return recog_12 (x1, insn, pnum_clobbers);

    case 135:
      if (pattern53 (x3, 
E_V4SFmode, 
E_V8HImode) != 0)
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_mask_operand (operands[3], E_QImode)
          || !
#line 2251 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 410; /* vcrnfs_v8hi */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (maybe_ne (SUBREG_BYTE (x2), 0))
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      if (!general_operand (operands[1], E_FPRX2mode)
          || !nonimmediate_operand (operands[0], E_TFmode)
          || GET_MODE (x2) != E_TFmode
          || !
#line 661 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 537; /* fprx2_to_tf */

    case UNSPEC:
      if (XVECLEN (x4, 0) != 3
          || XINT (x4, 1) != 71
          || GET_MODE (x4) != E_V16QImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != SUBREG
          || maybe_ne (SUBREG_BYTE (x5), 0)
          || GET_MODE (x5) != E_V16QImode)
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x6) != SUBREG
          || maybe_ne (SUBREG_BYTE (x6), 0)
          || GET_MODE (x6) != E_V16QImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      x9 = XVECEXP (x4, 0, 2);
      operands[3] = x9;
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern286 (x2, 
E_V16QImode) != 0
              || !
#line 756 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 540; /* *vec_permv16qi */

        case E_V8HImode:
          if (pattern286 (x2, 
E_V8HImode) != 0
              || !
#line 756 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 541; /* *vec_permv8hi */

        case E_V4SImode:
          if (pattern286 (x2, 
E_V4SImode) != 0
              || !
#line 756 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 542; /* *vec_permv4si */

        case E_V2DImode:
          if (pattern286 (x2, 
E_V2DImode) != 0
              || !
#line 756 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 543; /* *vec_permv2di */

        case E_V2DFmode:
          if (pattern286 (x2, 
E_V2DFmode) != 0
              || !
#line 756 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 544; /* *vec_permv2df */

        case E_V1TImode:
          if (pattern286 (x2, 
E_V1TImode) != 0
              || !
#line 756 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 545; /* *vec_permv1ti */

        case E_TImode:
          if (pattern286 (x2, 
E_TImode) != 0
              || !
#line 756 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 546; /* *vec_permti */

        case E_V4SFmode:
          if (pattern286 (x2, 
E_V4SFmode) != 0
              || !(
#line 756 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 38 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 547; /* *vec_permv4sf */

        case E_V1TFmode:
          if (pattern286 (x2, 
E_V1TFmode) != 0
              || !(
#line 756 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 38 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 548; /* *vec_permv1tf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (SUBREG_BYTE (x3))
    {
    case 0:
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case ROTATE:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          if (!contiguous_bitmask_operand (operands[3], E_DImode))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !const_int_operand (operands[2], E_SImode))
                return -1;
              if (
#line 4174 "../../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1592; /* *risbgn_and_subregdi_rotr */
              if (pnum_clobbers != NULL
                  && 
#line 4174 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                {
                  *pnum_clobbers = 1;
                  return 1593; /* *risbg_and_subregdi_rotr */
                }
              if (
#line 4187 "../../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return 1598; /* *risbgn_and_subregdi_rotl */
              if (pnum_clobbers == NULL
                  || !
#line 4187 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              *pnum_clobbers = 1;
              return 1599; /* *risbg_and_subregdi_rotl */

            case E_HImode:
              if (!register_operand (operands[1], E_HImode)
                  || !const_int_operand (operands[2], E_HImode))
                return -1;
              if (
#line 4174 "../../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1594; /* *risbgn_and_subregdi_rotr */
              if (pnum_clobbers != NULL
                  && 
#line 4174 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                {
                  *pnum_clobbers = 1;
                  return 1595; /* *risbg_and_subregdi_rotr */
                }
              if (
#line 4187 "../../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return 1600; /* *risbgn_and_subregdi_rotl */
              if (pnum_clobbers == NULL
                  || !
#line 4187 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              *pnum_clobbers = 1;
              return 1601; /* *risbg_and_subregdi_rotl */

            case E_QImode:
              if (!register_operand (operands[1], E_QImode)
                  || !const_int_operand (operands[2], E_QImode))
                return -1;
              if (
#line 4174 "../../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1596; /* *risbgn_and_subregdi_rotr */
              if (pnum_clobbers != NULL
                  && 
#line 4174 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                {
                  *pnum_clobbers = 1;
                  return 1597; /* *risbg_and_subregdi_rotr */
                }
              if (
#line 4187 "../../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return 1602; /* *risbgn_and_subregdi_rotl */
              if (pnum_clobbers == NULL
                  || !
#line 4187 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              *pnum_clobbers = 1;
              return 1603; /* *risbg_and_subregdi_rotl */

            default:
              return -1;
            }

        case SUBREG:
        case MEM:
          operands[1] = x4;
          if (!memory_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x2, 1);
          if (GET_CODE (x7) != CONST_INT
              || XWINT (x7, 0) != 2147483647L)
            return -1;
          if (
#line 4935 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 1678; /* *llgt_sidi */
          if (pnum_clobbers == NULL
              || !
#line 4945 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1679; /* *llgt_sidi_split */

        default:
          return -1;
        }

    case 4:
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      if (!contiguous_bitmask_nowrap_operand (operands[3], E_SImode))
        return -1;
      switch (GET_CODE (x4))
        {
        case LSHIFTRT:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!nonzero_shift_count_operand (operands[2], E_DImode))
            return -1;
          if (
#line 4397 "../../../gcc/config/s390/s390.md"
(TARGET_ZEC12))
            return 1630; /* *trunc_sidi_and_subreg_lshrt_nocc */
          if (pnum_clobbers == NULL
              || !
#line 4397 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
            return -1;
          *pnum_clobbers = 1;
          return 1631; /* *trunc_sidi_and_subreg_lshrt_clobbercc */

        case ZERO_EXTRACT:
          x6 = XEXP (x4, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x4, 2);
          operands[2] = x8;
          if (!nonzero_shift_count_operand (operands[2], E_SImode))
            return -1;
          if (
#line 4411 "../../../gcc/config/s390/s390.md"
(TARGET_ZEC12))
            return 1632; /* *trunc_sidi_and_subreg_ze_nocc */
          if (pnum_clobbers == NULL
              || !
#line 4411 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
            return -1;
          *pnum_clobbers = 1;
          return 1633; /* *trunc_sidi_and_subreg_ze_clobbercc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      switch (pattern2 (x1))
        {
        case 0:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1QImode)) - 1)
  ))
            return 865; /* *lshrv1qi3 */
          if (register_operand (operands[2], E_V1QImode)
              && 
#line 1463 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 947; /* vlshrv1qi3 */
          break;

        case 1:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2QImode)) - 1)
  ))
            return 869; /* *lshrv2qi3 */
          if (register_operand (operands[2], E_V2QImode)
              && 
#line 1463 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 948; /* vlshrv2qi3 */
          break;

        case 2:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4QImode)) - 1)
  ))
            return 873; /* *lshrv4qi3 */
          if (register_operand (operands[2], E_V4QImode)
              && 
#line 1463 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 949; /* vlshrv4qi3 */
          break;

        case 3:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8QImode)) - 1)
  ))
            return 877; /* *lshrv8qi3 */
          if (register_operand (operands[2], E_V8QImode)
              && 
#line 1463 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 950; /* vlshrv8qi3 */
          break;

        case 4:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V16QImode)) - 1)
  ))
            return 881; /* *lshrv16qi3 */
          if (register_operand (operands[2], E_V16QImode)
              && 
#line 1463 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 951; /* vlshrv16qi3 */
          break;

        case 5:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1HImode)) - 1)
  ))
            return 885; /* *lshrv1hi3 */
          if (register_operand (operands[2], E_V1HImode)
              && 
#line 1463 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 952; /* vlshrv1hi3 */
          break;

        case 6:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2HImode)) - 1)
  ))
            return 889; /* *lshrv2hi3 */
          if (register_operand (operands[2], E_V2HImode)
              && 
#line 1463 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 953; /* vlshrv2hi3 */
          break;

        case 7:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4HImode)) - 1)
  ))
            return 893; /* *lshrv4hi3 */
          if (register_operand (operands[2], E_V4HImode)
              && 
#line 1463 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 954; /* vlshrv4hi3 */
          break;

        case 8:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8HImode)) - 1)
  ))
            return 897; /* *lshrv8hi3 */
          if (register_operand (operands[2], E_V8HImode)
              && 
#line 1463 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 955; /* vlshrv8hi3 */
          break;

        case 9:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1SImode)) - 1)
  ))
            return 901; /* *lshrv1si3 */
          if (register_operand (operands[2], E_V1SImode)
              && 
#line 1463 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 956; /* vlshrv1si3 */
          break;

        case 10:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2SImode)) - 1)
  ))
            return 905; /* *lshrv2si3 */
          if (register_operand (operands[2], E_V2SImode)
              && 
#line 1463 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 957; /* vlshrv2si3 */
          break;

        case 11:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4SImode)) - 1)
  ))
            return 909; /* *lshrv4si3 */
          if (register_operand (operands[2], E_V4SImode)
              && 
#line 1463 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 958; /* vlshrv4si3 */
          break;

        case 12:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1DImode)) - 1)
  ))
            return 913; /* *lshrv1di3 */
          if (register_operand (operands[2], E_V1DImode)
              && 
#line 1463 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 959; /* vlshrv1di3 */
          break;

        case 13:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2DImode)) - 1)
  ))
            return 917; /* *lshrv2di3 */
          if (register_operand (operands[2], E_V2DImode)
              && 
#line 1463 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 960; /* vlshrv2di3 */
          break;

        case 14:
          if (
#line 9416 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2161; /* *lshrdi3_31 */
          if (
#line 678 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 2163; /* *lshrdi3 */
          break;

        case 15:
          return 2165; /* *lshrsi3 */

        default:
          break;
        }
      break;

    case ZERO_EXTRACT:
      res = recog_26 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 32]
      || GET_CODE (x2) != ZERO_EXTRACT
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x2, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!memory_operand (operands[0], E_QImode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[1] = x7;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_DImode)
      || !
#line 4677 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), 0, 64)
   && INTVAL (operands[1]) > 0
   && INTVAL (operands[1]) <= GET_MODE_BITSIZE (SImode)
   && INTVAL (operands[1]) % BITS_PER_UNIT == 0))
    return -1;
  return 1662; /* *insvdi_mem_reghigh */
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 4:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 3);
      operands[4] = x4;
      switch (XINT (x2, 1))
        {
        case 59:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!memory_operand (operands[3], E_BLKmode)
              || !const_mask_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern17 (x2, 
E_V4SImode) != 0
                  || !
#line 83 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V4SImode)))
                return -1;
              return 1; /* vec_gather_elementv4si */

            case E_V2DImode:
              if (pattern17 (x2, 
E_V2DImode) != 0
                  || !
#line 83 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V2DImode)))
                return -1;
              return 2; /* vec_gather_elementv2di */

            case E_V2DFmode:
              if (pattern126 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
                  || !
#line 83 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V2DFmode)))
                return -1;
              return 3; /* vec_gather_elementv2df */

            case E_V4SFmode:
              if (pattern126 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
                  || !(
#line 83 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 23 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE)))
                return -1;
              return 4; /* vec_gather_elementv4sf */

            default:
              return -1;
            }

        case 94:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_int_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern54 (x2, 
E_V16QImode) != 0
                  || !
#line 1037 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 176; /* verimv16qi */

            case E_V8HImode:
              if (pattern54 (x2, 
E_V8HImode) != 0
                  || !
#line 1037 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 177; /* verimv8hi */

            case E_V4SImode:
              if (pattern54 (x2, 
E_V4SImode) != 0
                  || !
#line 1037 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 178; /* verimv4si */

            case E_V2DImode:
              if (pattern54 (x2, 
E_V2DImode) != 0
                  || !
#line 1037 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 179; /* verimv2di */

            default:
              return -1;
            }

        case 129:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_V2DImode))
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          if (!register_operand (operands[2], E_V2DImode))
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_mask_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || GET_MODE (x2) != E_V16QImode
                  || !register_operand (operands[3], E_V16QImode)
                  || !
#line 1264 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
                return -1;
              return 276; /* vec_msumv2di */

            case E_TImode:
              if (!register_operand (operands[0], E_TImode)
                  || GET_MODE (x2) != E_TImode
                  || !register_operand (operands[3], E_TImode)
                  || !
#line 1275 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
                return -1;
              return 277; /* vmslg */

            default:
              return -1;
            }

        case 116:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_mask_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern54 (x2, 
E_V16QImode) != 0
                  || !
#line 1547 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 302; /* vstrcv16qi */

            case E_V8HImode:
              if (pattern54 (x2, 
E_V8HImode) != 0
                  || !
#line 1547 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 303; /* vstrcv8hi */

            case E_V4SImode:
              if (pattern54 (x2, 
E_V4SImode) != 0
                  || !
#line 1547 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 304; /* vstrcv4si */

            default:
              return -1;
            }

        case 31:
          if (pnum_clobbers == NULL)
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_BLKmode)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 0
              || GET_MODE (x7) != E_SImode)
            return -1;
          x5 = XVECEXP (x2, 0, 0);
          operands[2] = x5;
          x8 = XEXP (x6, 0);
          operands[3] = x8;
          if (!immediate_operand (operands[4], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern249 (x2, 
E_DImode) != 0
                  || !
#line 685 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 1540; /* *strlendi */

            case E_SImode:
              if (pattern249 (x2, 
E_SImode) != 0
                  || !
#line 685 "../../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 1541; /* *strlensi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      return recog_14 (x1, insn, pnum_clobbers);

    case 2:
      return recog_13 (x1, insn, pnum_clobbers);

    case 3:
      return recog_15 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_CONCAT:
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != VEC_CONCAT)
        return -1;
      x7 = XEXP (x6, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern168 (x3, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 582 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 511; /* *vec_vllezlfv4si */

        case E_V4SFmode:
          if (pattern168 (x3, 
E_V2SFmode, 
E_SFmode, 
E_V4SFmode) != 0
              || !
#line 582 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 512; /* *vec_vllezlfv4sf */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern107 (x3, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 2249 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1254; /* *vec_load_pairv2di */

        case E_V2DFmode:
          if (pattern107 (x3, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 2249 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1255; /* *vec_load_pairv2df */

        default:
          return -1;
        }

    case TRUNCATE:
      switch (pattern31 (x3, 
TRUNCATE))
        {
        case 0:
          if (!
#line 2437 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1342; /* vec_pack_trunc_v8hi */

        case 1:
          if (!
#line 2437 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1343; /* vec_pack_trunc_v4si */

        case 2:
          if (!
#line 2437 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1344; /* vec_pack_trunc_v2di */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      switch (pattern31 (x3, 
SS_TRUNCATE))
        {
        case 0:
          if (!
#line 2449 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1345; /* vec_pack_ssat_v8hi */

        case 1:
          if (!
#line 2449 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1346; /* vec_pack_ssat_v4si */

        case 2:
          if (!
#line 2449 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1347; /* vec_pack_ssat_v2di */

        default:
          return -1;
        }

    case US_TRUNCATE:
      switch (pattern31 (x3, 
US_TRUNCATE))
        {
        case 0:
          if (!
#line 2461 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1348; /* vec_pack_usat_v8hi */

        case 1:
          if (!
#line 2461 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1349; /* vec_pack_usat_v4si */

        case 2:
          if (!
#line 2461 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1350; /* vec_pack_usat_v2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x5))
    {
    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 0)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_TFmode)
              || GET_MODE (x5) != E_DFmode
              || !const_int_operand (operands[2], E_VOIDmode)
              || !
#line 2933 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1407; /* *trunctfdf2_vr */

        case E_DDmode:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !register_operand (operands[1], E_TDmode)
              || GET_MODE (x5) != E_DImode
              || !const_mask_operand (operands[2], E_DImode)
              || !
#line 5510 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 1;
          return 1751; /* *trunctddd2 */

        default:
          return -1;
        }

    case CLOBBER:
      if (!register_operand (operands[1], E_TFmode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!scratch_operand (operands[2], E_TFmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !
#line 5487 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 1749; /* trunctfdf2_fpr */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !
#line 5487 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 1750; /* trunctfsf2_fpr */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case STRICT_LOW_PART:
      if (pattern89 (x1) != 0
          || !subreg_register_operand (operands[0], E_HImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_HImode))
        return -1;
      return 1516; /* movstricthi */

    case SUBREG:
    case MEM:
      operands[0] = x3;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != USE)
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !
#line 2911 "../../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 1533; /* *mvc */

    case ZERO_EXTRACT:
      if (pattern89 (x1) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XEXP (x3, 2);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || !nonimmediate_operand (operands[3], E_DImode)
              || !(
#line 4281 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (DImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 64) && 
#line 678 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1611; /* *insvdi_clobbercc */

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || !nonimmediate_operand (operands[3], E_SImode)
              || !
#line 4281 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (SImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 32))
            return -1;
          return 1613; /* *insvsi_clobbercc */

        default:
          return -1;
        }

    case PC:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 1)
        return -1;
      x4 = XEXP (x2, 1);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x6) != E_DImode
              || !(
#line 10142 "../../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 685 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          return 2200; /* indirect_jump_via_thunkdi */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x6) != E_SImode
              || !(
#line 10142 "../../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 685 "../../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2201; /* indirect_jump_via_thunksi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (pattern192 (x6))
    {
    case 0:
      if (!(
#line 4115 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (DImode))) && 
#line 678 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 1581; /* *extzvdi_clobbercc */

    case 1:
      if (!
#line 4115 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (SImode))))
        return -1;
      return 1583; /* *extzvsi_clobbercc */

    default:
      return -1;
    }
}

 int
recog_96 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      switch (pattern92 (x1))
        {
        case 0:
          x6 = XEXP (x4, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTRACT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              if (!const_int_operand (operands[4], E_VOIDmode))
                return -1;
              x9 = XEXP (x6, 2);
              operands[5] = x9;
              if (!const_int_operand (operands[5], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern275 (x4, 
E_DImode) != 0
                      || !
#line 4147 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 64)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return -1;
                  return 1587; /* *risbg_ior_and_sr_zedi */

                case E_SImode:
                  if (pattern275 (x4, 
E_SImode) != 0
                      || !
#line 4147 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 32)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return -1;
                  return 1589; /* *risbg_ior_and_sr_zesi */

                default:
                  return -1;
                }

            case AND:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern261 (x4, 
E_DImode) != 0
                      || !(
#line 4297 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])) && 
#line 678 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1615; /* *insvdi_clobbercc_noshift */

                case E_SImode:
                  if (pattern261 (x4, 
E_SImode) != 0
                      || !
#line 4297 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])))
                    return -1;
                  return 1617; /* *insvsi_clobbercc_noshift */

                default:
                  return -1;
                }

            case ASHIFT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern262 (x4, 
E_DImode) != 0
                      || !(
#line 4351 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1) && 
#line 678 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1621; /* *insvdi_clobbercc_appendbitsleft */

                case E_SImode:
                  if (pattern262 (x4, 
E_SImode) != 0
                      || !
#line 4351 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1))
                    return -1;
                  return 1623; /* *insvsi_clobbercc_appendbitsleft */

                default:
                  return -1;
                }

            case LSHIFTRT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern263 (x4, 
E_DImode) != 0
                      || !(
#line 4366 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (DImode) - UINTVAL (operands[4])))) && 
#line 678 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1625; /* *risbg_di_ior_and_lshiftrt */

                case E_SImode:
                  if (pattern263 (x4, 
E_SImode) != 0
                      || !
#line 4366 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (SImode) - UINTVAL (operands[4])))))
                    return -1;
                  return 1627; /* *risbg_si_ior_and_lshiftrt */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
            case MEM:
              if (GET_CODE (x6) == SUBREG
                  && known_eq (SUBREG_BYTE (x6), 4)
                  && GET_MODE (x6) == E_SImode)
                {
                  x7 = XEXP (x6, 0);
                  if (GET_CODE (x7) == LSHIFTRT
                      && GET_MODE (x7) == E_DImode
                      && pattern226 (x4, 
E_SImode) == 0
                      && const_int_operand (operands[2], E_SImode))
                    {
                      x10 = XEXP (x7, 0);
                      operands[3] = x10;
                      if (register_operand (operands[3], E_DImode))
                        {
                          x11 = XEXP (x7, 1);
                          operands[4] = x11;
                          if (nonzero_shift_count_operand (operands[4], E_DImode)
                              && 
#line 4383 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == ~(HOST_WIDE_INT_M1U >> UINTVAL (operands[4]))))
                            return 1629; /* *risbg_sidi_ior_and_lshiftrt */
                        }
                    }
                }
              operands[3] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern248 (x4, 
E_DImode) != 0
                      || !(
#line 4480 "../../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1634; /* *rosbg_di_noshift */

                case E_SImode:
                  if (pattern248 (x4, 
E_SImode) != 0
                      || !
#line 4480 "../../../gcc/config/s390/s390.md"
(TARGET_Z10))
                    return -1;
                  return 1636; /* *rosbg_si_noshift */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1:
          if (!
#line 4495 "../../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 1638; /* *rosbg_di_rotl */

        case 2:
          if (!(
#line 4510 "../../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 678 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1640; /* *rosbg_di_srl_bitmask */

        case 3:
          if (!
#line 4510 "../../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 1642; /* *rosbg_si_srl_bitmask */

        case 4:
          if (!(
#line 4530 "../../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 678 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1644; /* *rosbg_di_sll_bitmask */

        case 5:
          if (!
#line 4530 "../../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 1646; /* *rosbg_si_sll_bitmask */

        default:
          return -1;
        }

    case ASHIFT:
      x12 = XVECEXP (x1, 0, 1);
      if (pattern88 (x12) != 0)
        return -1;
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern94 (x4))
            {
            case 0:
              if (!(
#line 4548 "../../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 1648; /* *rosbg_di_sll */

            case 1:
              if (!
#line 4548 "../../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              return 1650; /* *rosbg_si_sll */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x13) != E_TImode)
            return -1;
          x14 = XEXP (x13, 0);
          if (GET_CODE (x14) != CLZ
              || GET_MODE (x14) != E_DImode)
            return -1;
          x15 = XEXP (x5, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
            return -1;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != ZERO_EXTEND
              || GET_MODE (x6) != E_TImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != XOR
              || GET_MODE (x7) != E_DImode)
            return -1;
          x11 = XEXP (x7, 1);
          if (GET_CODE (x11) != LSHIFTRT)
            return -1;
          x16 = XEXP (x11, 1);
          if (GET_CODE (x16) != SUBREG
              || maybe_ne (SUBREG_BYTE (x16), 4)
              || GET_MODE (x16) != E_SImode)
            return -1;
          x17 = XEXP (x16, 0);
          if (GET_CODE (x17) != CLZ
              || GET_MODE (x17) != E_DImode
              || !register_operand (operands[0], E_TImode)
              || GET_MODE (x4) != E_TImode
              || GET_MODE (x5) != E_TImode)
            return -1;
          x18 = XEXP (x14, 0);
          operands[1] = x18;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x19 = XEXP (x11, 0);
          operands[2] = x19;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x10 = XEXP (x7, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x20 = XEXP (x17, 0);
          if (!rtx_equal_p (x20, operands[1])
              || !
#line 9362 "../../../gcc/config/s390/s390.md"
(UINTVAL (operands[2]) == HOST_WIDE_INT_1U << 63
   && TARGET_EXTIMM && TARGET_ZARCH))
            return -1;
          return 2157; /* clztidi2 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern95 (x1))
        {
        case 0:
          if (!(
#line 4567 "../../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1652; /* *rosbg_di_srl */

        case 1:
          if (!
#line 4567 "../../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 1654; /* *rosbg_si_srl */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      if (GET_CODE (x5) == SUBREG
          && pattern116 (x1) == 0
          && 
#line 4587 "../../../gcc/config/s390/s390.md"
(TARGET_Z10))
        return 1656; /* *rosbg_sidi_srl */
      if (pnum_clobbers != NULL
          && pattern117 (x1) == 0
          && 
#line 8443 "../../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        {
          *pnum_clobbers = 1;
          return 2057; /* *oc */
        }
      operands[1] = x5;
      switch (pattern119 (x1))
        {
        case 0:
          if (!
#line 8138 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2022; /* *iordi3 */

        case 1:
          if (
#line 8219 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return 2025; /* *iorsi3_zarch */
          if (!
#line 8247 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2026; /* *iorsi3_esa */

        case 2:
          if (
#line 8275 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return 2027; /* *iorhi3_zarch */
          if (!
#line 8291 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2028; /* *iorhi3_esa */

        case 3:
          if (
#line 8318 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return 2029; /* *iorqi3_zarch */
          if (!
#line 8336 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2030; /* *iorqi3_esa */

        default:
          return -1;
        }

    case NOT:
      x12 = XVECEXP (x1, 0, 1);
      if (pattern88 (x12) != 0)
        return -1;
      x13 = XEXP (x5, 0);
      operands[1] = x13;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern239 (x4, 
E_DImode) != 0
                  || !(
#line 8380 "../../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 678 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2040; /* *orcdi */

            case E_SImode:
              if (pattern239 (x4, 
E_SImode) != 0
                  || !
#line 8380 "../../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2042; /* *orcsi */

            default:
              return -1;
            }

        case NOT:
          switch (pattern214 (x4))
            {
            case 0:
              if (!(
#line 8420 "../../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 678 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2052; /* *nanddi */

            case 1:
              if (!
#line 8420 "../../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2054; /* *nandsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_110 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (load_multiple_operation (operands[0], E_VOIDmode))
        {
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (register_operand (operands[1], E_DImode)
                  && s_operand (operands[2], E_DImode)
                  && 
#line 3044 "../../../gcc/config/s390/s390.md"
(reload_completed && TARGET_ZARCH))
                return 1534; /* *load_multiple_di */
              break;

            case E_SImode:
              if (register_operand (operands[1], E_SImode)
                  && s_operand (operands[2], E_SImode)
                  && 
#line 3057 "../../../gcc/config/s390/s390.md"
(reload_completed))
                return 1535; /* *load_multiple_si */
              break;

            default:
              break;
            }
        }
      if (!store_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!s_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode)
              || !
#line 3136 "../../../gcc/config/s390/s390.md"
(reload_completed && TARGET_ZARCH))
            return -1;
          return 1536; /* *store_multiple_di */

        case E_SImode:
          if (!s_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode)
              || !
#line 3150 "../../../gcc/config/s390/s390.md"
(reload_completed))
            return -1;
          return 1537; /* *store_multiple_si */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x2, 0) != 3
          || XINT (x2, 1) != 18
          || !execute_operation (operands[0], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_VOIDmode))
        return -1;
      x6 = XVECEXP (x2, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x2, 0, 2);
      operands[3] = x7;
      if (larl_operand (operands[3], E_SImode)
          && 
#line 3169 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_INT
   && GET_MODE_SIZE (GET_MODE (operands[1])) <= UNITS_PER_WORD))
        return 1538; /* *execute_rl */
      if (!memory_operand (operands[2], E_BLKmode)
          || !
#line 3181 "../../../gcc/config/s390/s390.md"
(GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_INT
   && GET_MODE_SIZE (GET_MODE (operands[1])) <= UNITS_PER_WORD))
        return -1;
      return 1539; /* *execute */

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (register_operand (operands[0], E_V16QImode)
          && register_operand (operands[1], E_V16QImode)
          && 
#line 276 "../../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_1 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V16QImode)
          && general_operand (operands[1], E_V16QImode))
        {
          if (
#line 296 "../../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V16QImode, 0)))
            return gen_split_10 (insn, operands);
          if (
#line 310 "../../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V16QImode, 1)))
            return gen_split_19 (insn, operands);
        }
      if (!register_operand (operands[0], E_V16QImode)
          || !memory_operand (operands[1], E_V16QImode)
          || !
#line 330 "../../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_28 (insn, operands);

    case E_V8HImode:
      if (register_operand (operands[0], E_V8HImode)
          && register_operand (operands[1], E_V8HImode)
          && 
#line 276 "../../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_2 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V8HImode)
          && general_operand (operands[1], E_V8HImode))
        {
          if (
#line 296 "../../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V8HImode, 0)))
            return gen_split_11 (insn, operands);
          if (
#line 310 "../../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V8HImode, 1)))
            return gen_split_20 (insn, operands);
        }
      if (!register_operand (operands[0], E_V8HImode)
          || !memory_operand (operands[1], E_V8HImode)
          || !
#line 330 "../../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_29 (insn, operands);

    case E_V4SImode:
      if (register_operand (operands[0], E_V4SImode)
          && register_operand (operands[1], E_V4SImode)
          && 
#line 276 "../../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_3 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V4SImode)
          && general_operand (operands[1], E_V4SImode))
        {
          if (
#line 296 "../../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V4SImode, 0)))
            return gen_split_12 (insn, operands);
          if (
#line 310 "../../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V4SImode, 1)))
            return gen_split_21 (insn, operands);
        }
      if (!register_operand (operands[0], E_V4SImode)
          || !memory_operand (operands[1], E_V4SImode)
          || !
#line 330 "../../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_30 (insn, operands);

    case E_V4SFmode:
      if (register_operand (operands[0], E_V4SFmode)
          && register_operand (operands[1], E_V4SFmode)
          && 
#line 276 "../../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_4 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V4SFmode)
          && general_operand (operands[1], E_V4SFmode))
        {
          if (
#line 296 "../../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V4SFmode, 0)))
            return gen_split_13 (insn, operands);
          if (
#line 310 "../../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V4SFmode, 1)))
            return gen_split_22 (insn, operands);
        }
      if (!register_operand (operands[0], E_V4SFmode)
          || !memory_operand (operands[1], E_V4SFmode)
          || !
#line 330 "../../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_31 (insn, operands);

    case E_V2DImode:
      if (register_operand (operands[0], E_V2DImode)
          && register_operand (operands[1], E_V2DImode)
          && 
#line 276 "../../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_5 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V2DImode)
          && general_operand (operands[1], E_V2DImode))
        {
          if (
#line 296 "../../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V2DImode, 0)))
            return gen_split_14 (insn, operands);
          if (
#line 310 "../../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V2DImode, 1)))
            return gen_split_23 (insn, operands);
        }
      if (!register_operand (operands[0], E_V2DImode)
          || !memory_operand (operands[1], E_V2DImode)
          || !
#line 330 "../../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_32 (insn, operands);

    case E_V2DFmode:
      if (register_operand (operands[0], E_V2DFmode)
          && register_operand (operands[1], E_V2DFmode)
          && 
#line 276 "../../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_6 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V2DFmode)
          && general_operand (operands[1], E_V2DFmode))
        {
          if (
#line 296 "../../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V2DFmode, 0)))
            return gen_split_15 (insn, operands);
          if (
#line 310 "../../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V2DFmode, 1)))
            return gen_split_24 (insn, operands);
        }
      if (!register_operand (operands[0], E_V2DFmode)
          || !memory_operand (operands[1], E_V2DFmode)
          || !
#line 330 "../../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_33 (insn, operands);

    case E_V1TImode:
      if (register_operand (operands[0], E_V1TImode)
          && register_operand (operands[1], E_V1TImode)
          && 
#line 276 "../../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_7 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V1TImode)
          && general_operand (operands[1], E_V1TImode))
        {
          if (
#line 296 "../../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V1TImode, 0)))
            return gen_split_16 (insn, operands);
          if (
#line 310 "../../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V1TImode, 1)))
            return gen_split_25 (insn, operands);
        }
      if (!register_operand (operands[0], E_V1TImode)
          || !memory_operand (operands[1], E_V1TImode)
          || !
#line 330 "../../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_34 (insn, operands);

    case E_V1TFmode:
      if (register_operand (operands[0], E_V1TFmode)
          && register_operand (operands[1], E_V1TFmode)
          && 
#line 276 "../../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_8 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V1TFmode)
          && general_operand (operands[1], E_V1TFmode))
        {
          if (
#line 296 "../../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V1TFmode, 0)))
            return gen_split_17 (insn, operands);
          if (
#line 310 "../../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V1TFmode, 1)))
            return gen_split_26 (insn, operands);
        }
      if (!register_operand (operands[0], E_V1TFmode)
          || !memory_operand (operands[1], E_V1TFmode)
          || !
#line 330 "../../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_35 (insn, operands);

    case E_TFmode:
      if (register_operand (operands[0], E_TFmode)
          && register_operand (operands[1], E_TFmode)
          && (
#line 276 "../../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])) && 
#line 80 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return gen_split_9 (insn, operands);
      if (nonimmediate_operand (operands[0], E_TFmode)
          && general_operand (operands[1], E_TFmode))
        {
          if ((
#line 296 "../../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], TFmode, 0)) && 
#line 80 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return gen_split_18 (insn, operands);
          if ((
#line 310 "../../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], TFmode, 1)) && 
#line 80 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return gen_split_27 (insn, operands);
        }
      if (!register_operand (operands[0], E_TFmode)
          || !memory_operand (operands[1], E_TFmode)
          || !(
#line 330 "../../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)) && 
#line 80 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return NULL;
      return gen_split_36 (insn, operands);

    case E_TImode:
      if (nonimmediate_operand (operands[0], E_TImode)
          && general_operand (operands[1], E_TImode))
        {
          if (
#line 1699 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && s390_split_ok_p (operands[0], operands[1], TImode, 0)))
            return gen_split_142 (insn, operands);
          if (
#line 1713 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && s390_split_ok_p (operands[0], operands[1], TImode, 1)))
            return gen_split_143 (insn, operands);
        }
      if (!register_operand (operands[0], E_TImode))
        return NULL;
      if (memory_operand (operands[1], E_TImode)
          && 
#line 1730 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return gen_split_144 (insn, operands);
      if (!register_operand (operands[1], E_TImode)
          || !
#line 1748 "../../../gcc/config/s390/s390.md"
(TARGET_VX && reload_completed
   && GENERAL_REG_P (operands[0])
   && VECTOR_REG_P (operands[1])))
        return NULL;
      return gen_split_145 (insn, operands);

    case E_DImode:
      if (register_operand (operands[0], E_DImode))
        {
          if (register_operand (operands[1], E_DImode))
            {
              if (
#line 1990 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && ACCESS_REG_P (operands[0]) && reload_completed
   && dead_or_set_p (insn, operands[1])))
                return gen_split_148 (insn, operands);
              if (
#line 2001 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && ACCESS_REG_P (operands[0]) && reload_completed
   && !dead_or_set_p (insn, operands[1])))
                return gen_split_149 (insn, operands);
            }
          if (memory_operand (operands[1], E_DImode)
              && 
#line 2039 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed && TARGET_Z10
   && larl_operand (XEXP (operands[1], 0), SImode)))
            return gen_split_150 (insn, operands);
        }
      if (nonimmediate_operand (operands[0], E_DImode)
          && general_operand (operands[1], E_DImode))
        {
          if (
#line 2052 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DImode)
   && !s_operand (operands[1], DImode)
   && s390_split_ok_p (operands[0], operands[1], DImode, 0)))
            return gen_split_151 (insn, operands);
          if (
#line 2068 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DImode)
   && !s_operand (operands[1], DImode)
   && s390_split_ok_p (operands[0], operands[1], DImode, 1)))
            return gen_split_152 (insn, operands);
        }
      if (!register_operand (operands[0], E_DImode)
          || !memory_operand (operands[1], E_DImode)
          || !
#line 2084 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !FP_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_153 (insn, operands);

    case E_FPRX2mode:
      if (nonimmediate_operand (operands[0], E_FPRX2mode)
          && general_operand (operands[1], E_FPRX2mode))
        {
          if ((
#line 2627 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], FPRX2mode)
   && !s_operand (operands[1], FPRX2mode)
   && s390_split_ok_p (operands[0], operands[1], FPRX2mode, 0)) && 
#line 671 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return gen_split_156 (insn, operands);
          if ((
#line 2643 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], FPRX2mode)
   && !s_operand (operands[1], FPRX2mode)
   && s390_split_ok_p (operands[0], operands[1], FPRX2mode, 1)) && 
#line 671 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return gen_split_159 (insn, operands);
        }
      if (register_operand (operands[0], E_FPRX2mode)
          && memory_operand (operands[1], E_FPRX2mode))
        {
          if ((
#line 2659 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && GENERAL_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)) && 
#line 671 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return gen_split_162 (insn, operands);
          if ((
#line 2675 "../../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[1])
   && FP_REG_P (operands[0])) && 
#line 671 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return gen_split_165 (insn, operands);
        }
      if (!memory_operand (operands[0], E_FPRX2mode)
          || !register_operand (operands[1], E_FPRX2mode)
          || !(
#line 2691 "../../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[0])
   && FP_REG_P (operands[1])) && 
#line 671 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return NULL;
      return gen_split_168 (insn, operands);

    case E_TDmode:
      if (nonimmediate_operand (operands[0], E_TDmode)
          && general_operand (operands[1], E_TDmode))
        {
          if (
#line 2627 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], TDmode)
   && !s_operand (operands[1], TDmode)
   && s390_split_ok_p (operands[0], operands[1], TDmode, 0)))
            return gen_split_157 (insn, operands);
          if (
#line 2643 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], TDmode)
   && !s_operand (operands[1], TDmode)
   && s390_split_ok_p (operands[0], operands[1], TDmode, 1)))
            return gen_split_160 (insn, operands);
        }
      if (register_operand (operands[0], E_TDmode)
          && memory_operand (operands[1], E_TDmode))
        {
          if (
#line 2659 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && GENERAL_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
            return gen_split_163 (insn, operands);
          if (
#line 2675 "../../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[1])
   && FP_REG_P (operands[0])))
            return gen_split_166 (insn, operands);
        }
      if (!memory_operand (operands[0], E_TDmode)
          || !register_operand (operands[1], E_TDmode)
          || !
#line 2691 "../../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[0])
   && FP_REG_P (operands[1])))
        return NULL;
      return gen_split_169 (insn, operands);

    case E_DFmode:
      if (nonimmediate_operand (operands[0], E_DFmode)
          && general_operand (operands[1], E_DFmode))
        {
          if (
#line 2799 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DFmode)
   && !s_operand (operands[1], DFmode)
   && s390_split_ok_p (operands[0], operands[1], DFmode, 0)))
            return gen_split_170 (insn, operands);
          if (
#line 2815 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DFmode)
   && !s_operand (operands[1], DFmode)
   && s390_split_ok_p (operands[0], operands[1], DFmode, 1)))
            return gen_split_172 (insn, operands);
        }
      if (!register_operand (operands[0], E_DFmode)
          || !memory_operand (operands[1], E_DFmode)
          || !
#line 2831 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !FP_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_174 (insn, operands);

    case E_DDmode:
      if (nonimmediate_operand (operands[0], E_DDmode)
          && general_operand (operands[1], E_DDmode))
        {
          if (
#line 2799 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DDmode)
   && !s_operand (operands[1], DDmode)
   && s390_split_ok_p (operands[0], operands[1], DDmode, 0)))
            return gen_split_171 (insn, operands);
          if (
#line 2815 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DDmode)
   && !s_operand (operands[1], DDmode)
   && s390_split_ok_p (operands[0], operands[1], DDmode, 1)))
            return gen_split_173 (insn, operands);
        }
      if (!register_operand (operands[0], E_DDmode)
          || !memory_operand (operands[1], E_DDmode)
          || !
#line 2831 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !FP_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_175 (insn, operands);

    case E_QImode:
      if (!memory_operand (operands[0], E_QImode)
          || !memory_operand (operands[1], E_QImode)
          || !
#line 2921 "../../../gcc/config/s390/s390.md"
(reload_completed))
        return NULL;
      return gen_split_176 (insn, operands);

    default:
      return NULL;
    }
}
